package info.aspirecn.iov.sjjh.supplier10000057.util;

import info.aspirecn.iov.sjjh.supplier10000057.constant.CommonConstant;
import okhttp3.*;

import java.io.IOException;
import java.util.concurrent.TimeUnit;

/**
 * @author xusonglin
 * @version V1.0
 **/
public class OkHttpUtil {
    private static OkHttpClient okHttpClient = new OkHttpClient.Builder().build();

    public static String doPost(String url, String body, int outTime) throws IOException {
        MediaType mediaType = MediaType.parse(CommonConstant.MEDIA_TYPE);
        RequestBody requestBody = RequestBody.create(mediaType, body);
        Request okRequest = new Request.Builder()
                .post(requestBody)
                .url(url)
                .build();
        OkHttpClient client = okHttpClient.newBuilder()
                .connectTimeout(outTime, TimeUnit.MILLISECONDS)
                .readTimeout(outTime, TimeUnit.MILLISECONDS)
                .writeTimeout(outTime, TimeUnit.MILLISECONDS)
                .build();

        String responseContext = "";
        Response response = client.newCall(okRequest).execute();
        if (response != null) {
            responseContext = response.body().string();
        }
        return responseContext;
    }

    public static String doPost(String url, RequestBody body, int outTime, String token) throws IOException {
        MediaType mediaType = MediaType.parse("multipart/form-data");
        Request okRequest = new Request.Builder()
                .post(body)
                .header("Authorization", token)
                .url(url)
                .build();
        OkHttpClient client = okHttpClient.newBuilder()
                .connectTimeout(outTime, TimeUnit.MILLISECONDS)
                .readTimeout(outTime, TimeUnit.MILLISECONDS)
                .writeTimeout(outTime, TimeUnit.MILLISECONDS)
                .build();

        String responseContext = "";
        Response response = client.newCall(okRequest).execute();
        if (response != null) {
            responseContext = response.body().string();
        }
        return responseContext;
    }


    public static String doGet(String url, int outTime, String token) throws IOException {
        Request okRequest = new Request.Builder()
                .get()
                .header("Authorization", token)
                .url(url)
                .build();
        OkHttpClient client = okHttpClient.newBuilder()
                .connectTimeout(outTime, TimeUnit.MILLISECONDS)
                .readTimeout(outTime, TimeUnit.MILLISECONDS)
                .writeTimeout(outTime, TimeUnit.MILLISECONDS)
                .build();

        String responseContext = "";
        Response response = client.newCall(okRequest).execute();
        if (response != null) {
            responseContext = response.body().string();
        }
        return responseContext;
    }

    public static String doDelete(String url, String body, int outTime, String token) throws IOException {
        MediaType mediaType = MediaType.parse(CommonConstant.MEDIA_TYPE);
        RequestBody requestBody = RequestBody.create(mediaType, body);
        Request okRequest = new Request.Builder()
                .delete(requestBody)
                .header("Authorization", token)
                .url(url)
                .build();
        OkHttpClient client = okHttpClient.newBuilder()
                .connectTimeout(outTime, TimeUnit.MILLISECONDS)
                .readTimeout(outTime, TimeUnit.MILLISECONDS)
                .writeTimeout(outTime, TimeUnit.MILLISECONDS)
                .build();

        String responseContext = "";
        Response response = client.newCall(okRequest).execute();
        if (response != null) {
            responseContext = response.body().string();
        }
        return responseContext;
    }

    public static String doPut(String url, String body, int outTime, String token) throws IOException {
        MediaType mediaType = MediaType.parse(CommonConstant.MEDIA_TYPE);
        RequestBody requestBody = RequestBody.create(mediaType, body);
        Request okRequest = new Request.Builder()
                .put(requestBody)
                .header("Authorization", token)
                .url(url)
                .build();
        OkHttpClient client = okHttpClient.newBuilder()
                .connectTimeout(outTime, TimeUnit.MILLISECONDS)
                .readTimeout(outTime, TimeUnit.MILLISECONDS)
                .writeTimeout(outTime, TimeUnit.MILLISECONDS)
                .build();

        String responseContext = "";
        Response response = client.newCall(okRequest).execute();
        if (response != null) {
            responseContext = response.body().string();
        }
        return responseContext;
    }
}
